Index: /branches/TerminationCriteria/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithm.cs
===================================================================
--- /branches/TerminationCriteria/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithm.cs	(revision 12365)
+++ /branches/TerminationCriteria/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithm.cs	(revision 12366)
@@ -490,6 +490,6 @@
         qualityTerminationCriterion.Name = maximization ? "Maximum Quality" : "Minimum Quality";
         qualityTerminationCriterion.Comparison = new Comparison(maximization ? ComparisonType.GreaterOrEqual : ComparisonType.LessOrEqual);
-        qualityTerminationCriterion.LeftSideParameter.ActualName = qualityAnalyzer.CurrentBestQualityParameter.Name;
-        qualityTerminationCriterion.RightSideParameter.Value = new DoubleValue(maximization ? double.MaxValue : double.MinValue);
+        qualityTerminationCriterion.ValueParameter.ActualName = qualityAnalyzer.CurrentBestQualityParameter.Name;
+        qualityTerminationCriterion.ThresholdParameter.Value = new DoubleValue(maximization ? double.MaxValue : double.MinValue);
       }
     }
Index: /branches/TerminationCriteria/HeuristicLab.Termination/3.3/ComparisonTerminationCriterion.cs
===================================================================
--- /branches/TerminationCriteria/HeuristicLab.Termination/3.3/ComparisonTerminationCriterion.cs	(revision 12365)
+++ /branches/TerminationCriteria/HeuristicLab.Termination/3.3/ComparisonTerminationCriterion.cs	(revision 12366)
@@ -30,11 +30,9 @@
   [Item("ComparisonTerminationCriterion", "An termination criterion which compares to values.")]
   [StorableClass]
-  public class ComparisonTerminationCriterion<T> : TerminationCriterion where T : class, IItem, IComparable {
-    public ILookupParameter<T> LeftSideParameter {
-      get { return (ILookupParameter<T>)Parameters["LeftSide"]; }
+  public class ComparisonTerminationCriterion<T> : ThresholdTerminationCriterion<T> where T : class, IItem, IComparable {
+    public ILookupParameter<T> ValueParameter {
+      get { return (ILookupParameter<T>)Parameters["Value"]; }
     }
-    public IValueLookupParameter<T> RightSideParameter {
-      get { return (IValueLookupParameter<T>)Parameters["RightSide"]; }
-    }
+
     private ValueParameter<Comparison> ComparisonParameter {
       get { return (ValueParameter<Comparison>)Parameters["Comparison"]; }
@@ -48,12 +46,6 @@
     [StorableConstructor]
     protected ComparisonTerminationCriterion(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      Initialize();
-    }
     protected ComparisonTerminationCriterion(ComparisonTerminationCriterion<T> original, Cloner cloner)
-      : base(original, cloner) {
-      Initialize();
-    }
+      : base(original, cloner) { }
     public override IDeepCloneable Clone(Cloner cloner) {
       return new ComparisonTerminationCriterion<T>(this, cloner);
@@ -61,30 +53,23 @@
     public ComparisonTerminationCriterion()
       : base() {
-      Parameters.Add(new LookupParameter<T>("LeftSide", "The left side of the comparison."));
-      Parameters.Add(new ValueLookupParameter<T>("RightSide", "The right side of the comparison."));
+      Parameters.Add(new LookupParameter<T>("Value", "The left side value of the comparison."));
       Parameters.Add(new ValueParameter<Comparison>("Comparison", "The type of comparison.", new Comparison(ComparisonType.GreaterOrEqual)) { Hidden = true });
-
-      Initialize();
     }
     public ComparisonTerminationCriterion(string leftSideActualName, string rightSideActualName, ComparisonType comparison = ComparisonType.GreaterOrEqual)
       : this() {
-      LeftSideParameter.ActualName = leftSideActualName;
-      RightSideParameter.ActualName = rightSideActualName;
+      ValueParameter.ActualName = leftSideActualName;
+      ThresholdParameter.ActualName = rightSideActualName;
       Comparison.Value = comparison;
     }
     public ComparisonTerminationCriterion(string leftSideActualName, T rightSideValue, ComparisonType comparison = ComparisonType.GreaterOrEqual)
       : this() {
-      LeftSideParameter.ActualName = leftSideActualName;
-      RightSideParameter.Value = rightSideValue;
+      ValueParameter.ActualName = leftSideActualName;
+      ThresholdParameter.Value = rightSideValue;
       Comparison.Value = comparison;
     }
 
-    private void Initialize() {
-      RightSideParameter.ToStringChanged += (s, a) => OnToStringChanged();
-    }
-
     protected override bool CheckTermination() {
-      IComparable lhs = LeftSideParameter.ActualValue;
-      IComparable rhs = RightSideParameter.ActualValue;
+      IComparable lhs = ValueParameter.ActualValue;
+      IComparable rhs = ThresholdParameter.ActualValue;
 
       int i = lhs.CompareTo(rhs);
@@ -107,8 +92,5 @@
     }
 
-    public override string ToString() {
-      if (RightSideParameter.Value == null) return Name;
-      else return Name + ": " + RightSideParameter.Value;
-    }
+
   }
 }
Index: /branches/TerminationCriteria/HeuristicLab.Termination/3.3/ExecutionTimeTimeTerminationCriterion.cs
===================================================================
--- /branches/TerminationCriteria/HeuristicLab.Termination/3.3/ExecutionTimeTimeTerminationCriterion.cs	(revision 12365)
+++ /branches/TerminationCriteria/HeuristicLab.Termination/3.3/ExecutionTimeTimeTerminationCriterion.cs	(revision 12366)
@@ -24,5 +24,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -30,9 +29,5 @@
   [Item("ExecutionTimeTimeTerminationCriterion", "")]
   [StorableClass]
-  public class ExecutionTimeTimeTerminationCriterion : TerminationCriterion {
-
-    private IValueParameter<TimeSpanValue> MaximumExecutionTimeParameter {
-      get { return (IValueParameter<TimeSpanValue>)Parameters["MaximumExecutionTime"]; }
-    }
+  public class ExecutionTimeTimeTerminationCriterion : ThresholdTerminationCriterion<TimeSpanValue> {
 
     [Storable]
@@ -52,9 +47,11 @@
     public ExecutionTimeTimeTerminationCriterion(IExecutable executable, TimeSpan maximumExecutionTime) {
       this.executable = executable;
-      Parameters.Add(new ValueParameter<TimeSpanValue>("MaximumExecutionTime", "The maximum execution time of an algortihm.", new TimeSpanValue(maximumExecutionTime)));
+      ThresholdParameter.Value = new TimeSpanValue(maximumExecutionTime);
+
+      Name = "Maximum Execution Time";
     }
 
     protected override bool CheckTermination() {
-      var max = MaximumExecutionTimeParameter.Value.Value;
+      var max = ThresholdParameter.Value.Value;
 
       return executable.ExecutionTime > max;
Index: /branches/TerminationCriteria/HeuristicLab.Termination/3.3/HeuristicLab.Termination-3.3.csproj
===================================================================
--- /branches/TerminationCriteria/HeuristicLab.Termination/3.3/HeuristicLab.Termination-3.3.csproj	(revision 12365)
+++ /branches/TerminationCriteria/HeuristicLab.Termination/3.3/HeuristicLab.Termination-3.3.csproj	(revision 12366)
@@ -141,9 +141,10 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Views\ComparisonTerminationCriterionView.cs">
+    <Compile Include="ThresholdTerminationCriterion.cs" />
+    <Compile Include="Views\ThresholdTerminationCriterionView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="Views\ComparisonTerminationCriterionView.Designer.cs">
-      <DependentUpon>ComparisonTerminationCriterionView.cs</DependentUpon>
+    <Compile Include="Views\ThresholdTerminationCriterionView.Designer.cs">
+      <DependentUpon>ThresholdTerminationCriterionView.cs</DependentUpon>
     </Compile>
     <Compile Include="ITerminationCriterion.cs" />
Index: anches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ComparisonTerminationCriterionView.Designer.cs
===================================================================
--- /branches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ComparisonTerminationCriterionView.Designer.cs	(revision 12365)
+++ 	(revision )
@@ -1,78 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Termination.Views {
-  partial class ComparisonTerminationCriterionView<T> {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.SuspendLayout();
-      // 
-      // viewHost
-      // 
-      this.viewHost.Caption = "View";
-      this.viewHost.Content = null;
-      this.viewHost.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.viewHost.Enabled = false;
-      this.viewHost.Location = new System.Drawing.Point(0, 0);
-      this.viewHost.Name = "viewHost";
-      this.viewHost.ReadOnly = false;
-      this.viewHost.Size = new System.Drawing.Size(150, 150);
-      this.viewHost.TabIndex = 0;
-      this.viewHost.ViewsLabelVisible = true;
-      this.viewHost.ViewType = null;
-      // 
-      // ComparisonTerminationCriterionView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.viewHost);
-      this.Name = "ComparisonTerminationCriterionView";
-      this.ResumeLayout(false);
-
-    }
-
-    #endregion
-
-    private HeuristicLab.MainForm.WindowsForms.ViewHost viewHost;
-  }
-}
Index: anches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ComparisonTerminationCriterionView.cs
===================================================================
--- /branches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ComparisonTerminationCriterionView.cs	(revision 12365)
+++ 	(revision )
@@ -1,53 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Termination.Views {
-
-  [View("ComparisonTerminationCriterion View")]
-  [Content(typeof(ComparisonTerminationCriterion<>), true)]
-  public partial class ComparisonTerminationCriterionView<T> : ItemView where T : class, IItem, IComparable {
-
-    public new ComparisonTerminationCriterion<T> Content {
-      get { return (ComparisonTerminationCriterion<T>)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public ComparisonTerminationCriterionView() {
-      InitializeComponent();
-    }
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      viewHost.Content = null;
-      if (Content != null) {
-        if (Content.RightSideParameter.Value != null)
-          viewHost.Content = Content.RightSideParameter.Value;
-        else
-          viewHost.Content = Content.RightSideParameter;
-      }
-    }
-  }
-}
Index: /branches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ThresholdTerminationCriterionView.Designer.cs
===================================================================
--- /branches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ThresholdTerminationCriterionView.Designer.cs	(revision 12366)
+++ /branches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ThresholdTerminationCriterionView.Designer.cs	(revision 12366)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Termination.Views {
+  partial class ThresholdTerminationCriterionView<T> {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.SuspendLayout();
+      // 
+      // viewHost
+      // 
+      this.viewHost.Caption = "View";
+      this.viewHost.Content = null;
+      this.viewHost.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.viewHost.Enabled = false;
+      this.viewHost.Location = new System.Drawing.Point(0, 0);
+      this.viewHost.Name = "viewHost";
+      this.viewHost.ReadOnly = false;
+      this.viewHost.Size = new System.Drawing.Size(150, 150);
+      this.viewHost.TabIndex = 0;
+      this.viewHost.ViewsLabelVisible = true;
+      this.viewHost.ViewType = null;
+      // 
+      // ThresholdTerminationCriterionView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.viewHost);
+      this.Name = "ThresholdTerminationCriterionView";
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private HeuristicLab.MainForm.WindowsForms.ViewHost viewHost;
+  }
+}
Index: /branches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ThresholdTerminationCriterionView.cs
===================================================================
--- /branches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ThresholdTerminationCriterionView.cs	(revision 12366)
+++ /branches/TerminationCriteria/HeuristicLab.Termination/3.3/Views/ThresholdTerminationCriterionView.cs	(revision 12366)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Termination.Views {
+
+  [View("ThresholdTerminationCriterion View")]
+  [Content(typeof(ThresholdTerminationCriterion<>), true)]
+  public partial class ThresholdTerminationCriterionView<T> : ItemView where T : class, IItem, IComparable {
+
+    public new ThresholdTerminationCriterion<T> Content {
+      get { return (ThresholdTerminationCriterion<T>)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public ThresholdTerminationCriterionView() {
+      InitializeComponent();
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      viewHost.Content = null;
+      if (Content != null) {
+        if (Content.ThresholdParameter.Value != null)
+          viewHost.Content = Content.ThresholdParameter.Value;
+        else
+          viewHost.Content = Content.ThresholdParameter;
+      }
+    }
+  }
+}